package com.cringe_studios.cringe_authenticator_library;

public enum OTPType {
	HOTP("HMAC-based One-Time Password"),
	TOTP("Time-based One-Time Password");

	private String friendlyName;

	private OTPType(String nFriendlyName) {
		friendlyName = nFriendlyName;
	}

	public String getFriendlyName() {
		return friendlyName;
	}

	public OTP instance(String secret, OTPAlgorithm algorithm, int digits, long counter, long periodInSeconds, boolean checksum) {
		switch(this) {
			case HOTP:
				return new com.cringe_studios.cringe_authenticator_library.impl.HOTP(secret, algorithm, digits, counter, periodInSeconds, checksum);
			case TOTP:
				return new com.cringe_studios.cringe_authenticator_library.impl.TOTP(secret, algorithm, digits, counter, periodInSeconds, checksum);
			default: return null;
		}	
	}
}
